/*
 * AttServiceHandler.java
 *
 * Created on January 27, 2007, 12:32 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package wsHandler;

import java.io.IOException;
import java.util.Collections;
import java.util.Iterator;
import java.util.Set;
import javax.xml.namespace.QName;
import javax.xml.soap.AttachmentPart;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPMessage;
import javax.xml.ws.handler.MessageContext;
import javax.xml.ws.handler.soap.SOAPHandler;
import javax.xml.ws.handler.soap.SOAPMessageContext;

public class AttServiceHandler implements SOAPHandler<SOAPMessageContext> {
    public boolean handleMessage(SOAPMessageContext messageContext) {
        SOAPMessage msg = messageContext.getMessage();
        Boolean outboundProperty = (Boolean)
        messageContext.get(MessageContext.MESSAGE_OUTBOUND_PROPERTY);
        if(outboundProperty==false){
            System.out.println("Handler engaged incomming messages....");
        }
        else{
            AttachmentPart attPart = msg.createAttachmentPart("outgoing  is a test 1","text/plain");
            msg.addAttachmentPart(attPart);
            messageContext.setMessage(msg);
            System.out.println("Handler engaged outgoing  messages....");
            Iterator it = msg.getAttachments();
            try {
                while(it.hasNext()) {
                    AttachmentPart part = (AttachmentPart) it.next();
                    System.out.println("** Received attachment: "+
                            part.getContent());
                }
            } catch (SOAPException e) {
                e.printStackTrace();
            }
        }
        return true;
    }
    
    public Set<QName> getHeaders() {
        return Collections.EMPTY_SET;
    }
    
    public boolean handleFault(SOAPMessageContext messageContext) {
        return true;
    }
    
    public void close(MessageContext context) {
        context.clear();
    }
}
